//sub
// sueda
// November, 2014
//

#pragma  once
#ifndef __Camera__
#define __Camera__

#define GLM_FORCE_RADIANS
#include "glm/glm.hpp"

class MatrixStack;

class Camera
{
public:
	
	enum {
		ROTATE = 0,
		TRANSLATE,
		SCALE
	};

	Camera();
	virtual ~Camera();
	void setWindowSize(float w, float h);
	void update(const bool *keys, const glm::vec2 &mouse, int dt);
	void applyProjectionMatrix(MatrixStack *P) const;
	void applyViewMatrix(MatrixStack *MV) const;
	void mouseClicked(int x, int y);
	glm::vec2 mouseMoved(int x, int y);
	void Reset();
	
private:
	float aspect;
	float fovy;
	float znear;
	float zfar;
	glm::vec2 mousePrev;
	glm::vec3 position;

	glm::vec2 rotations;
	glm::vec3 translations;
	float scale;
	int state;
	float rfactor;
	float tfactor;
	float sfactor;
};

#endif
